VTK: vtkQuadraticPolygon Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkQuadraticPolygon Class Reference

a cell that represents a parabolic n-sided polygon More...

`#include <vtkQuadraticPolygon.h>`

Inheritance diagram for vtkQuadraticPolygon:
[legend]
Collaboration diagram for vtkQuadraticPolygon:
[legend]

## Public Types
typedef vtkNonLinearCell | Superclass
Public Types inherited from vtkNonLinearCell
typedef vtkCell | Superclass
Public Types inherited from vtkCell
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkQuadraticPolygon * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | GetCellType () override
| Implement the vtkCell API. More...
int | GetCellDimension () override
| Return the topological dimensional of the cell (0,1,2, or 3). More...
int | GetNumberOfEdges () override
| Return the number of edges in the cell. More...
int | GetNumberOfFaces () override
| Return the number of faces in the cell. More...
vtkCell * | GetEdge (int) override
| Return the edge cell from the edgeId of the cell. More...
vtkCell * | GetFace (int) override
| Return the face cell from the faceId of the cell. More...
int | IsPrimaryCell () override
| Return whether this cell type has a fixed topology or whether the topology varies depending on the data (e.g., vtkConvexPointSet). More...
void | Derivatives (int subId, const double pcoords[3], const double *values, int dim, double *derivs) override
| Compute derivatives given cell subId and parametric coordinates. More...
virtual bool | GetUseMVCInterpolation ()
| Set/Get the flag indicating whether to use Mean Value Coordinate for the interpolation. More...
virtual void | SetUseMVCInterpolation (bool)
| Set/Get the flag indicating whether to use Mean Value Coordinate for the interpolation. More...
Public Member Functions inherited from vtkNonLinearCell
vtkNonLinearCell * | NewInstance () const
int | IsLinear () override
| Non-linear cells require special treatment (tessellation) when converting to graphics primitives (during mapping). More...
virtual bool | StableClip (double value, vtkDataArray *cellScalars, vtkIncrementalPointLocator *locator, vtkCellArray *connectivity, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd, int insideOut)
| Clip the cell based on the input cellScalars and the specified value. More...
Public Member Functions inherited from vtkCell
vtkCell * | NewInstance () const
void | Initialize (int npts, const vtkIdType *pts, vtkPoints *p)
| Initialize cell from outside with point ids and point coordinates specified. More...
void | Initialize (int npts, vtkPoints *p)
| Initialize the cell with point coordinates specified. More...
virtual void | ShallowCopy (vtkCell *c)
| Copy this cell by reference counting the internal data structures. More...
virtual void | DeepCopy (vtkCell *c)
| Copy this cell by completely copying internal data structures. More...
virtual int | RequiresInitialization ()
| Some cells require initialization prior to access. More...
virtual void | Initialize ()
virtual int | IsExplicitCell ()
| Explicit cells require additional representational information beyond the usual cell type and connectivity list information. More...
virtual int | RequiresExplicitFaceRepresentation ()
| Determine whether the cell requires explicit face representation, and methods for setting and getting the faces (see vtkPolyhedron for example usage of these methods). More...
virtual void | SetFaces (vtkIdType *vtkNotUsed(faces))
virtual vtkIdType * | GetFaces ()
vtkPoints * | GetPoints ()
| Get the point coordinates for the cell. More...
vtkIdType | GetNumberOfPoints () const
| Return the number of points in the cell. More...
vtkIdList * | GetPointIds ()
| Return the list of point ids defining the cell. More...
vtkIdType | GetPointId (int ptId)
| For cell point i, return the actual point id. More...
virtual int | Inflate (double dist)
| Inflates the cell. More...
virtual double | ComputeBoundingSphere (double center[3]) const
| Computes the bounding sphere of the cell. More...
void | GetBounds (double bounds[6])
| Compute cell bounding box (xmin,xmax,ymin,ymax,zmin,zmax). More...
double * | GetBounds ()
| Compute cell bounding box (xmin,xmax,ymin,ymax,zmin,zmax). More...
double | GetLength2 ()
| Compute Length squared of cell (i.e., bounding box diagonal squared). More...
virtual int | GetParametricCenter (double pcoords[3])
| Return center of the cell in parametric coordinates. More...
virtual double | GetParametricDistance (const double pcoords[3])
| Return the distance of the parametric coordinate provided to the cell. More...
virtual double * | GetParametricCoords ()
| Return a contiguous array of parametric coordinates of the points defining this cell. More...
virtual void | InterpolateFunctions (const double vtkNotUsed(pcoords)[3], double *vtkNotUsed(weight))
| Compute the interpolation functions/derivatives (aka shape functions/derivatives) No-ops at this level. More...
virtual void | InterpolateDerivs (const double vtkNotUsed(pcoords)[3], double *vtkNotUsed(derivs))
virtual int | IntersectWithCell (vtkCell *other, double tol=0.0)
| Intersects with an other cell. More...
virtual int | IntersectWithCell (vtkCell *other, const vtkBoundingBox &boudingBox, const vtkBoundingBox &otherBoundingBox, double tol=0.0)
| Intersects with an other cell. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkQuadraticPolygon * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkQuadraticPolygon * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkNonLinearCell
static vtkTypeBool | IsTypeOf (const char *type)
static vtkNonLinearCell * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkCell
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCell * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkQuadraticPolygon ()
| ~vtkQuadraticPolygon () override
Protected Member Functions inherited from vtkNonLinearCell
| vtkNonLinearCell ()
| ~vtkNonLinearCell () override=default
Protected Member Functions inherited from vtkCell
| vtkCell ()
| ~vtkCell () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | GetPermutationToPolygon (vtkIdType nb, vtkIdList *permutation)
| Methods to transform a vtkPolygon variable into a vtkQuadraticPolygon variable. More...
static void | PermuteFromPolygon (vtkIdType nb, double *values)
| Methods to transform a vtkPolygon variable into a vtkQuadraticPolygon variable. More...
static void | ConvertFromPolygon (vtkIdList *ids)
| Methods to transform a vtkPolygon variable into a vtkQuadraticPolygon variable. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Protected Attributes
vtkPolygon * | Polygon
vtkQuadraticEdge * | Edge
bool | UseMVCInterpolation
Protected Attributes inherited from vtkCell
double | Bounds [6]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
static void | ComputeCentroid (vtkIdTypeArray *ids, vtkPoints *pts, double centroid[3])
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
static int | PointInPolygon (double x[3], int numPts, double *pts, double bounds[6], double n[3])
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
static double | DistanceToPolygon (double x[3], int numPts, double *pts, double bounds[6], double closest[3])
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
static int | IntersectPolygonWithPolygon (int npts, double *pts, double bounds[6], int npts2, double *pts2, double bounds2[6], double tol, double x[3])
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
static int | IntersectConvex2DCells (vtkCell *cell1, vtkCell *cell2, double tol, double p0[3], double p1[3])
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
int | CellBoundary (int subId, const double pcoords[3], vtkIdList *pts) override
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
void | Contour (double value, vtkDataArray *cellScalars, vtkIncrementalPointLocator *locator, vtkCellArray *verts, vtkCellArray *lines, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd) override
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
void | Clip (double value, vtkDataArray *cellScalars, vtkIncrementalPointLocator *locator, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd, int insideOut) override
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
int | EvaluatePosition (const double x[3], double closestPoint[3], int &subId, double pcoords[3], double &dist2, double weights[]) override
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
void | EvaluateLocation (int &subId, const double pcoords[3], double x[3], double *weights) override
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId) override
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
void | InterpolateFunctions (const double x[3], double *weights) override
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
int | ParameterizePolygon (double p0[3], double p10[3], double &l10, double p20[3], double &l20, double n[3])
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
int | Triangulate (vtkIdList *outTris)
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
int | Triangulate (int index, vtkIdList *ptIds, vtkPoints *pts) override
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
int | NonDegenerateTriangulate (vtkIdList *outTris)
| These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called. More...
void | InitializePolygon ()
| Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable. More...
static void | GetPermutationFromPolygon (vtkIdType nb, vtkIdList *permutation)
| Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable. More...
static void | PermuteToPolygon (vtkIdType nbPoints, double *inPoints, double *outPoints)
| Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable. More...
static void | PermuteToPolygon (vtkCell *inCell, vtkCell *outCell)
| Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable. More...
static void | PermuteToPolygon (vtkPoints *inPoints, vtkPoints *outPoints)
| Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable. More...
static void | PermuteToPolygon (vtkIdTypeArray *inIds, vtkIdTypeArray *outIds)
| Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable. More...
static void | PermuteToPolygon (vtkDataArray *inDataArray, vtkDataArray *outDataArray)
| Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable. More...

## Additional Inherited Members
Public Attributes inherited from vtkCell
vtkPoints * | Points
vtkIdList * | PointIds

## Detailed Description

a cell that represents a parabolic n-sided polygon

vtkQuadraticPolygon is a concrete implementation of vtkNonLinearCell to represent a 2D n-sided (2*n nodes) parabolic polygon. The polygon cannot have any internal holes, and cannot self-intersect. The cell includes a mid-edge node for each of the n edges of the cell. The ordering of the 2*n points defining the cell are point ids (0..n-1 and n..2*n-1) where ids 0..n-1 define the corner vertices of the polygon; ids n..2*n-1 define the midedge nodes. Define the polygon with points ordered in the counter- clockwise direction; do not repeat the last point.

See also
  vtkQuadraticEdge vtkQuadraticTriangle vtkQuadraticTetra vtkQuadraticHexahedron vtkQuadraticWedge vtkQuadraticPyramid

Online Examples:

Tests:
  vtkQuadraticPolygon (Tests)

Definition at line 44 of file vtkQuadraticPolygon.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkNonLinearCell vtkQuadraticPolygon::Superclass

Definition at line 48 of file vtkQuadraticPolygon.h.

## Constructor & Destructor Documentation

## ◆ vtkQuadraticPolygon()

vtkQuadraticPolygon::vtkQuadraticPolygon | ( |  | ) |
| protected

## ◆ ~vtkQuadraticPolygon()

vtkQuadraticPolygon::~vtkQuadraticPolygon | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkQuadraticPolygon* vtkQuadraticPolygon::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkQuadraticPolygon::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkQuadraticPolygon::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkNonLinearCell.

## ◆ SafeDownCast()

static vtkQuadraticPolygon* vtkQuadraticPolygon::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkQuadraticPolygon::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkNonLinearCell.

## ◆ NewInstance()

vtkQuadraticPolygon* vtkQuadraticPolygon::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkQuadraticPolygon::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkNonLinearCell.

## ◆ GetCellType()

int vtkQuadraticPolygon::GetCellType | ( |  | ) |
| inlineoverridevirtual

Implement the vtkCell API.

See the vtkCell API for descriptions of these methods.

Implements vtkCell.

Definition at line 55 of file vtkQuadraticPolygon.h.

## ◆ GetCellDimension()

int vtkQuadraticPolygon::GetCellDimension | ( |  | ) |
| inlineoverridevirtual

Return the topological dimensional of the cell (0,1,2, or 3).

Implements vtkCell.

Definition at line 56 of file vtkQuadraticPolygon.h.

## ◆ GetNumberOfEdges()

int vtkQuadraticPolygon::GetNumberOfEdges | ( |  | ) |
| inlineoverridevirtual

Return the number of edges in the cell.

Implements vtkCell.

Definition at line 57 of file vtkQuadraticPolygon.h.

## ◆ GetNumberOfFaces()

int vtkQuadraticPolygon::GetNumberOfFaces | ( |  | ) |
| inlineoverridevirtual

Return the number of faces in the cell.

Implements vtkCell.

Definition at line 58 of file vtkQuadraticPolygon.h.

## ◆ GetEdge()

vtkCell* vtkQuadraticPolygon::GetEdge | ( | int | edgeId | ) |
| overridevirtual

Return the edge cell from the edgeId of the cell.

Implements vtkCell.

## ◆ GetFace()

vtkCell* vtkQuadraticPolygon::GetFace | ( | int | faceId | ) |
| inlineoverridevirtual

Return the face cell from the faceId of the cell.

The returned vtkCell is an object owned by this instance, hence the return value must not be deleted by the caller.

Warning
  Repeat calls to this function for different face ids will change the data stored in the internal member object whose pointer is returned by this function.
  THIS METHOD IS NOT THREAD SAFE.

Implements vtkCell.

Definition at line 60 of file vtkQuadraticPolygon.h.

## ◆ IsPrimaryCell()

int vtkQuadraticPolygon::IsPrimaryCell | ( |  | ) |
| inlineoverridevirtual

Return whether this cell type has a fixed topology or whether the topology varies depending on the data (e.g., vtkConvexPointSet).

This compares to composite cells that are typically composed of primary cells (e.g., a triangle strip composite cell is made up of triangle primary cells).

Reimplemented from vtkCell.

Definition at line 61 of file vtkQuadraticPolygon.h.

## ◆ CellBoundary()

int vtkQuadraticPolygon::CellBoundary | ( | int | subId,
|  | const double | pcoords[3],
|  | vtkIdList * | pts
| ) |  |
| overridevirtual

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

Implements vtkCell.

## ◆ Contour()

void vtkQuadraticPolygon::Contour | ( | double | value,
|  | vtkDataArray * | cellScalars,
|  | vtkIncrementalPointLocator * | locator,
|  | vtkCellArray * | verts,
|  | vtkCellArray * | lines,
|  | vtkCellArray * | polys,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd
| ) |  |
| overridevirtual

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

Implements vtkCell.

## ◆ Clip()

void vtkQuadraticPolygon::Clip | ( | double | value,
|  | vtkDataArray * | cellScalars,
|  | vtkIncrementalPointLocator * | locator,
|  | vtkCellArray * | polys,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd,
|  | int | insideOut
| ) |  |
| overridevirtual

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

Implements vtkCell.

## ◆ EvaluatePosition()

int vtkQuadraticPolygon::EvaluatePosition | ( | const double | x[3],
|  | double | closestPoint[3],
|  | int & | subId,
|  | double | pcoords[3],
|  | double & | dist2,
|  | double | weights[]
| ) |  |
| overridevirtual

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

Implements vtkCell.

## ◆ EvaluateLocation()

void vtkQuadraticPolygon::EvaluateLocation | ( | int & | subId,
|  | const double | pcoords[3],
|  | double | x[3],
|  | double * | weights
| ) |  |
| overridevirtual

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

Implements vtkCell.

## ◆ IntersectWithLine()

int vtkQuadraticPolygon::IntersectWithLine | ( | const double | p1[3],
|  | const double | p2[3],
|  | double | tol,
|  | double & | t,
|  | double | x[3],
|  | double | pcoords[3],
|  | int & | subId
| ) |  |
| overridevirtual

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

Implements vtkCell.

## ◆ InterpolateFunctions()

void vtkQuadraticPolygon::InterpolateFunctions | ( | const double | x[3],
|  | double * | weights
| ) |  |
| override

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

## ◆ ComputeCentroid()

static void vtkQuadraticPolygon::ComputeCentroid | ( | vtkIdTypeArray * | ids,
|  | vtkPoints * | pts,
|  | double | centroid[3]
| ) |  |
| static

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

## ◆ ParameterizePolygon()

int vtkQuadraticPolygon::ParameterizePolygon | ( | double | p0[3],
|  | double | p10[3],
|  | double & | l10,
|  | double | p20[3],
|  | double & | l20,
|  | double | n[3]
| ) |  |

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

## ◆ PointInPolygon()

static int vtkQuadraticPolygon::PointInPolygon | ( | double | x[3],
|  | int | numPts,
|  | double * | pts,
|  | double | bounds[6],
|  | double | n[3]
| ) |  |
| static

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

## ◆ Triangulate() [1/2]

int vtkQuadraticPolygon::Triangulate | ( | vtkIdList * | outTris | ) |

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

## ◆ Triangulate() [2/2]

int vtkQuadraticPolygon::Triangulate | ( | int | index,
|  | vtkIdList * | ptIds,
|  | vtkPoints * | pts
| ) |  |
| overridevirtual

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

Implements vtkCell.

## ◆ NonDegenerateTriangulate()

int vtkQuadraticPolygon::NonDegenerateTriangulate | ( | vtkIdList * | outTris | ) |

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

## ◆ DistanceToPolygon()

static double vtkQuadraticPolygon::DistanceToPolygon | ( | double | x[3],
|  | int | numPts,
|  | double * | pts,
|  | double | bounds[6],
|  | double | closest[3]
| ) |  |
| static

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

## ◆ IntersectPolygonWithPolygon()

static int vtkQuadraticPolygon::IntersectPolygonWithPolygon | ( | int | npts,
|  | double * | pts,
|  | double | bounds[6],
|  | int | npts2,
|  | double * | pts2,
|  | double | bounds2[6],
|  | double | tol,
|  | double | x[3]
| ) |  |
| static

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

## ◆ IntersectConvex2DCells()

static int vtkQuadraticPolygon::IntersectConvex2DCells | ( | vtkCell * | cell1,
|  | vtkCell * | cell2,
|  | double | tol,
|  | double | p0[3],
|  | double | p1[3]
| ) |  |
| static

These methods are based on the vtkPolygon ones : the vtkQuadraticPolygon (with n edges and 2*n points) is transform into a vtkPolygon (with 2*n edges and 2*n points) and the vtkPolygon methods are called.

## ◆ Derivatives()

void vtkQuadraticPolygon::Derivatives | ( | int | subId,
|  | const double | pcoords[3],
|  | const double * | values,
|  | int | dim,
|  | double * | derivs
| ) |  |
| overridevirtual

Compute derivatives given cell subId and parametric coordinates.

The values array is a series of data value(s) at the cell points. There is a one-to-one correspondence between cell point and data value(s). Dim is the number of data values per cell point. Derivs are derivatives in the x-y-z coordinate directions for each data value. Thus, if computing derivatives for a scalar function in a hexahedron, dim=1, 8 values are supplied, and 3 deriv values are returned (i.e., derivatives in x-y-z directions). On the other hand, if computing derivatives of velocity (vx,vy,vz) dim=3, 24 values are supplied ((vx,vy,vz)1, (vx,vy,vz)2, ....()8), and 9 deriv values are returned ((d(vx)/dx),(d(vx)/dy),(d(vx)/dz), (d(vy)/dx),(d(vy)/dy), (d(vy)/dz), (d(vz)/dx),(d(vz)/dy),(d(vz)/dz)).

Implements vtkCell.

## ◆ GetUseMVCInterpolation()

virtual bool vtkQuadraticPolygon::GetUseMVCInterpolation | ( |  | ) |
| virtual

Set/Get the flag indicating whether to use Mean Value Coordinate for the interpolation.

If true, InterpolateFunctions() uses the Mean Value Coordinate to compute weights. Otherwise, the conventional 1/r^2 method is used. The UseMVCInterpolation parameter is set to true by default.

## ◆ SetUseMVCInterpolation()

virtual void vtkQuadraticPolygon::SetUseMVCInterpolation | ( | bool |  | ) |
| virtual

Set/Get the flag indicating whether to use Mean Value Coordinate for the interpolation.

If true, InterpolateFunctions() uses the Mean Value Coordinate to compute weights. Otherwise, the conventional 1/r^2 method is used. The UseMVCInterpolation parameter is set to true by default.

## ◆ GetPermutationFromPolygon()

static void vtkQuadraticPolygon::GetPermutationFromPolygon | ( | vtkIdType | nb,
|  | vtkIdList * | permutation
| ) |  |
| staticprotected

Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable.

## ◆ PermuteToPolygon() [1/5]

static void vtkQuadraticPolygon::PermuteToPolygon | ( | vtkIdType | nbPoints,
|  | double * | inPoints,
|  | double * | outPoints
| ) |  |
| staticprotected

Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable.

## ◆ PermuteToPolygon() [2/5]

static void vtkQuadraticPolygon::PermuteToPolygon | ( | vtkCell * | inCell,
|  | vtkCell * | outCell
| ) |  |
| staticprotected

Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable.

## ◆ PermuteToPolygon() [3/5]

static void vtkQuadraticPolygon::PermuteToPolygon | ( | vtkPoints * | inPoints,
|  | vtkPoints * | outPoints
| ) |  |
| staticprotected

Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable.

## ◆ PermuteToPolygon() [4/5]

static void vtkQuadraticPolygon::PermuteToPolygon | ( | vtkIdTypeArray * | inIds,
|  | vtkIdTypeArray * | outIds
| ) |  |
| staticprotected

Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable.

## ◆ PermuteToPolygon() [5/5]

static void vtkQuadraticPolygon::PermuteToPolygon | ( | vtkDataArray * | inDataArray,
|  | vtkDataArray * | outDataArray
| ) |  |
| staticprotected

Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable.

## ◆ InitializePolygon()

void vtkQuadraticPolygon::InitializePolygon | ( |  | ) |
| protected

Methods to transform a vtkQuadraticPolygon variable into a vtkPolygon variable.

## ◆ GetPermutationToPolygon()

static void vtkQuadraticPolygon::GetPermutationToPolygon | ( | vtkIdType | nb,
|  | vtkIdList * | permutation
| ) |  |
| staticprotected

Methods to transform a vtkPolygon variable into a vtkQuadraticPolygon variable.

## ◆ PermuteFromPolygon()

static void vtkQuadraticPolygon::PermuteFromPolygon | ( | vtkIdType | nb,
|  | double * | values
| ) |  |
| staticprotected

Methods to transform a vtkPolygon variable into a vtkQuadraticPolygon variable.

## ◆ ConvertFromPolygon()

static void vtkQuadraticPolygon::ConvertFromPolygon | ( | vtkIdList * | ids | ) |
| staticprotected

Methods to transform a vtkPolygon variable into a vtkQuadraticPolygon variable.

## Member Data Documentation

## ◆ Polygon

vtkPolygon* vtkQuadraticPolygon::Polygon
| protected

Definition at line 118 of file vtkQuadraticPolygon.h.

## ◆ Edge

vtkQuadraticEdge* vtkQuadraticPolygon::Edge
| protected

Definition at line 119 of file vtkQuadraticPolygon.h.

## ◆ UseMVCInterpolation

bool vtkQuadraticPolygon::UseMVCInterpolation
| protected

Definition at line 123 of file vtkQuadraticPolygon.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkQuadraticPolygon.h